// ======================================================================
//
// DebugKey.h
// jeff grills
//
// copyright 1995 origin systems inc
//
// ======================================================================

#ifndef DEBUG_KEY_H
#define DEBUG_KEY_H

// ======================================================================
// get the game-dependent keyboard contexts included

#include "DebugKeyGame.def"

#if USE_DEBUG_KEY

// ======================================================================
// variables & routines

extern int   *DoNotUseDKeyContext;
extern int16 *DoNotUseDKeyPressed;
extern int16 *DoNotUseDKeyDown;

inline void DKeyUpdate(void)
{
	*DoNotUseDKeyPressed = 0;
}

inline void DKeyPress(int k)
{
	*DoNotUseDKeyPressed |= static_cast<int16>(BIT(k));
	*DoNotUseDKeyDown |= static_cast<int16>(BIT(k));
}

inline void DKeyRelease(int k)
{
	*DoNotUseDKeyDown &= static_cast<int16>(BIT_NOT(k));
}

inline void DKeySetContext(int c)
{
	*DoNotUseDKeyContext = c;
}

inline bool DKeyIsContext(int c)
{
	return (*DoNotUseDKeyContext == c);
}

inline bool DKeyIsDown(int k)
{
	return ((*DoNotUseDKeyPressed & BIT(k)) || (*DoNotUseDKeyDown & BIT(k)));
}

inline bool DKeyIsPressed(int k)
{
	return (*DoNotUseDKeyPressed & BIT(k)) != 0;
}

// ======================================================================
#else

inline void DKeyUpdate(void)
{
}

inline void DKeyPress(int)
{
}

inline void DKeyRelease(int)
{
}

inline void DKeySetContext(int)
{
}

inline bool DKeyIsContext(int)
{
	return 0;
}

inline bool DKeyIsDown(int)
{
	return 0;
}

inline bool DKeyIsPressed(int)
{
	return 0;
}

// ======================================================================

#endif
#endif
